# Importion of modules
import os

import pygame

import letters

# Initialize pygame
pygame.init()


class Scientist( pygame.sprite.Sprite ):
	"""
	"""

	def __init__( self, number_of_liquid_machines ):
		"""
		"""
		pygame.sprite.Sprite.__init__( self )

		# Set up some basic properties of the player, the scientist.
		self.score = 0
		self.name = ""
		self.number_of_liquid_machines = number_of_liquid_machines
		self.chosen_liquid_machine = 0

		self.left_right_arrow_key_still_down = False;

		# Set up the "movements".
		self.movements = { 	"choose_right": False,
										"choose_left": False,
										"increase_output": False,
										"decrease_output": False }

		self.update_score( 0 )


	def update_score( self, add_to_score ):
		"""
		"""

		self.score += add_to_score

		score = letters.Word( "SCORE: " + str( self.score ), [ 190, 50 ], ( ( 100, 255, 255 ) ), 4 )
		self.image = score.image
		self.rect = score.rect

		
	def update( self, events ):
		"""
		"""

		self.check_keys( events )
		self.change_machine_to_operate()


	def check_keys( self, events ):
		"""
		This method checks if the player has pressed any keys and alters the values of some elements of "self.movements" accordingly.
		"""

		for event in events:
			if event.type == pygame.KEYDOWN:
				if event.key == pygame.K_LEFT and not self.left_right_arrow_key_still_down:
					self.movements["choose_left"] = True
					self.left_right_arrow_key_still_down = True
				elif event.key == pygame.K_RIGHT and not self.left_right_arrow_key_still_down:
					self.movements["choose_right"] = True
					self.left_right_arrow_key_still_down = True					
				elif event.key == pygame.K_UP:
					self.movements["increase_output"] = True
				elif event.key == pygame.K_DOWN:
					self.movements["decrease_output"] = True
			elif event.type == pygame.KEYUP:
				if event.key == pygame.K_LEFT:
					self.movements["choose_left"] = False
					self.left_right_arrow_key_still_down = False
				elif event.key == pygame.K_RIGHT:
					self.movements["choose_right"] = False
					self.left_right_arrow_key_still_down = False
				elif event.key == pygame.K_UP:
					self.movements["increase_output"] = False
				elif event.key == pygame.K_DOWN:
					self.movements["decrease_output"] = False


	def change_machine_to_operate( self ):
		"""
		"""

		if self.movements["choose_right"] and self.chosen_liquid_machine < self.number_of_liquid_machines-1:
			self.chosen_liquid_machine += 1
			self.movements["choose_right"] = False
		elif self.movements["choose_left"] and self.chosen_liquid_machine > 0:
			self.chosen_liquid_machine -= 1
			self.movements["choose_left" ] = False
		
