# Importion of modules
import os
import copy

import pygame

# Initialize pygame
pygame.init()

# Matrix layout for our letters and numbers.
letter_A = [[ 1, 1, 1, 1, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 1, 1, 1, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 0, 0, 1 ],				
				[ 1, 0, 0, 0, 1 ] ]


letter_B = [	[ 1, 1, 1, 1, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 0, 1, 0 ],
				[ 1, 1, 1, 1, 0 ],
				[ 1, 0, 0, 1, 0 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 0, 0, 1 ],				
				[ 1, 1, 1, 1, 1 ] ]

letter_C = [	[ 1, 1, 1, 1, 1 ],
				[ 1, 0, 0, 0, 0 ],
				[ 1, 0, 0, 0, 0 ],
				[ 1, 0, 0, 0, 0 ],
				[ 1, 0, 0, 0, 0 ],
				[ 1, 0, 0, 0, 0 ],
				[ 1, 0, 0, 0, 0 ],				
				[ 1, 1, 1, 1, 1 ] ]

letter_D = [[ 1, 1, 1, 0, 0 ],
				[ 1, 0, 0, 1, 0 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 0, 1, 0 ],				
				[ 1, 1, 1, 0, 0 ] ]

letter_E = [	[ 1, 1, 1, 1, 1 ],
				[ 1, 0, 0, 0, 0 ],
				[ 1, 0, 0, 0, 0 ],
				[ 1, 1, 1, 1, 1 ],
				[ 1, 0, 0, 0, 0 ],
				[ 1, 0, 0, 0, 0 ],
				[ 1, 0, 0, 0, 0 ],				
				[ 1, 1, 1, 1, 1 ] ]

letter_F = [	[ 1, 1, 1, 1, 1 ],
				[ 1, 0, 0, 0, 0 ],
				[ 1, 0, 0, 0, 0 ],
				[ 1, 1, 1, 1, 1 ],
				[ 1, 0, 0, 0, 0 ],
				[ 1, 0, 0, 0, 0 ],
				[ 1, 0, 0, 0, 0 ],				
				[ 1, 0, 0, 0, 0 ] ]

letter_G = [[ 1, 1, 1, 1, 1 ],
				[ 1, 0, 0, 0, 0 ],
				[ 1, 0, 0, 0, 0 ],
				[ 1, 0, 1, 1, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 1, 1, 1, 1 ] ]

letter_H = [[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 1, 1, 1, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 0, 0, 1 ],				
				[ 1, 0, 0, 0, 1 ] ]


letter_I = [	[ 1, 1, 1, 1, 1 ],
				[ 0, 0, 1, 0, 0 ],
				[ 0, 0, 1, 0, 0 ],
				[ 0, 0, 1, 0, 0 ],
				[ 0, 0, 1, 0, 0 ],
				[ 0, 0, 1, 0, 0 ],
				[ 0, 0, 1, 0, 0 ],				
				[ 1, 1, 1, 1, 1 ] ]

letter_J = [	[ 1, 1, 1, 1, 1 ],
				[ 0, 0, 0, 0, 1 ],
				[ 0, 0, 0, 0, 1 ],
				[ 0, 0, 0, 0, 1 ],
				[ 0, 0, 0, 0, 1 ],
				[ 0, 0, 0, 0, 1 ],
				[ 0, 0, 0, 0, 1 ],				
				[ 1, 1, 1, 1, 1 ] ]

letter_K = [[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 0, 1, 0 ],
				[ 1, 0, 1, 0, 0 ],
				[ 1, 1, 0, 0, 0 ],
				[ 1, 1, 0, 0, 0 ],
				[ 1, 0, 1, 0, 0 ],
				[ 1, 0, 0, 1, 0 ],				
				[ 1, 0, 0, 0, 1 ] ]

letter_L = [	[ 1, 0, 0, 0, 0 ],
				[ 1, 0, 0, 0, 0 ],
				[ 1, 0, 0, 0, 0 ],
				[ 1, 0, 0, 0, 0 ],
				[ 1, 0, 0, 0, 0 ],
				[ 1, 0, 0, 0, 0 ],
				[ 1, 0, 0, 0, 0 ],				
				[ 1, 1, 1, 1, 1 ] ]

letter_M = [[ 1, 0, 0, 0, 1 ],
				[ 1, 1, 0, 1, 1 ],
				[ 1, 1, 0, 1, 1 ],
				[ 1, 0, 1, 0, 1 ],
				[ 1, 0, 1, 0, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 0, 0, 1 ],				
				[ 1, 0, 0, 0, 1 ] ]

letter_N = [[ 1, 0, 0, 0, 1 ],
				[ 1, 1, 0, 0, 1 ],
				[ 1, 1, 0, 0, 1 ],
				[ 1, 0, 1, 0, 1 ],
				[ 1, 0, 1, 0, 1 ],
				[ 1, 0, 0, 1, 1 ],
				[ 1, 0, 0, 1, 1 ],
				[ 1, 0, 0, 0, 1 ] ]

letter_O = [[ 0, 1, 1, 1, 0 ],
				[ 1, 1, 0, 1, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 1, 0, 1, 1 ],				
				[ 0, 1, 1, 1, 0 ] ]

letter_P = [	[ 1, 1, 1, 1, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 1, 1, 1, 1 ],
				[ 1, 0, 0, 0, 0 ],
				[ 1, 0, 0, 0, 0 ],
				[ 1, 0, 0, 0, 0 ],				
				[ 1, 0, 0, 0, 0 ] ]

letter_Q = [[ 1, 1, 1, 1, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 1, 1, 0 ],
				[ 0, 1, 0, 1, 0 ],				
				[ 0, 0, 0, 0, 1 ] ]

letter_R = [[ 1, 1, 1, 1, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 1, 1, 1, 1 ],
				[ 1, 1, 0, 0, 0 ],
				[ 1, 0, 1, 0, 0 ],
				[ 1, 0, 0, 1, 0 ],				
				[ 1, 0, 0, 0, 1 ] ]

letter_S = [[ 1, 1, 1, 1, 1 ],
				[ 1, 0, 0, 0, 0 ],
				[ 1, 0, 0, 0, 0 ],
				[ 1, 1, 1, 1, 1 ],
				[ 0, 0, 0, 0, 1 ],
				[ 0, 0, 0, 0, 1 ],
				[ 0, 0, 0, 0, 1 ],				
				[ 1, 1, 1, 1, 1 ] ]

letter_T = [[ 1, 1, 1, 1, 1 ],
				[ 0, 0, 1, 0, 0 ],
				[ 0, 0, 1, 0, 0 ],
				[ 0, 0, 1, 0, 0 ],
				[ 0, 0, 1, 0, 0 ],
				[ 0, 0, 1, 0, 0 ],
				[ 0, 0, 1, 0, 0 ],
				[ 0, 0, 1, 0, 0 ] ]	

letter_U = [[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 0, 0, 1 ],				
				[ 1, 1, 1, 1, 1 ] ]

letter_V = [[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 0, 1, 0, 1, 0 ],
				[ 0, 1, 0, 1, 0 ],
				[ 0, 1, 0, 1, 0 ],
				[ 0, 0, 1, 0, 0 ],
				[ 0, 0, 1, 0, 0 ],				
				[ 0, 0, 1, 0, 0 ] ]

letter_W = [[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 1, 0, 1 ],
				[ 1, 0, 1, 0, 1 ],
				[ 1, 0, 1, 0, 1 ],
				[ 1, 1, 0, 1, 1 ],
				[ 0, 1, 0, 1, 0 ],				
				[ 0, 1, 0, 1, 0 ] ]

letter_X = [[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 0, 1, 0, 1, 0 ],
				[ 0, 0, 1, 0, 0 ],
				[ 0, 0, 1, 0, 0 ],
				[ 0, 1, 0, 1, 0 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 0, 0, 1 ] ]

letter_Y = [[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 0, 1, 0, 1, 0 ],
				[ 0, 0, 1, 0, 0 ],
				[ 0, 0, 1, 0, 0 ],
				[ 0, 0, 1, 0, 0 ],
				[ 0, 0, 1, 0, 0 ],				
				[ 0, 0, 1, 0, 0 ] ]

letter_Z = [[ 1, 1, 1, 1, 1 ],
				[ 0, 0, 0, 0, 1 ],
				[ 0, 0, 0, 1, 1 ],
				[ 0, 0, 1, 1, 0 ],
				[ 0, 1, 1, 0, 0 ],
				[ 1, 1, 0, 0, 0 ],
				[ 1, 0, 0, 0, 0 ],
				[ 1, 1, 1, 1, 1 ] ]	

num_0 =   [[ 1, 1, 1, 1, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 0, 0, 1 ],				
				[ 1, 1, 1, 1, 1 ] ]

num_1 =   [[ 0, 0, 0, 0, 1 ],
				[ 0, 0, 0, 0, 1 ],
				[ 0, 0, 0, 0, 1 ],
				[ 0, 0, 0, 0, 1 ],
				[ 0, 0, 0, 0, 1 ],
				[ 0, 0, 0, 0, 1 ],
				[ 0, 0, 0, 0, 1 ],				
				[ 0, 0, 0, 0, 1 ] ]

num_2 =   [[ 1, 1, 1, 1, 1 ],
				[ 0, 0, 0, 0, 1 ],
				[ 0, 0, 0, 0, 1 ],
				[ 1, 1, 1, 1, 1 ],
				[ 1, 0, 0, 0, 0 ],
				[ 1, 0, 0, 0, 0 ],
				[ 1, 0, 0, 0, 0 ],
				[ 1, 1, 1, 1, 1 ] ]	

num_3   = [[ 1, 1, 1, 1, 1 ],
				[ 0, 0, 0, 0, 1 ],
				[ 0, 0, 0, 0, 1 ],
				[ 1, 1, 1, 1, 1 ],
				[ 0, 0, 0, 0, 1 ],
				[ 0, 0, 0, 0, 1 ],
				[ 0, 0, 0, 0, 1 ],				
				[ 1, 1, 1, 1, 1 ] ]

num_4   = [[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 1, 1, 1, 1 ],
				[ 0, 0, 0, 0, 1 ],
				[ 0, 0, 0, 0, 1 ],				
				[ 0, 0, 0, 0, 1 ] ]

num_5   = [[ 1, 1, 1, 1, 1 ],
				[ 1, 0, 0, 0, 0 ],
				[ 1, 0, 0, 0, 0 ],
				[ 1, 1, 1, 1, 1 ],
				[ 0, 0, 0, 0, 1 ],
				[ 0, 0, 0, 0, 1 ],
				[ 0, 0, 0, 0, 1 ],				
				[ 1, 1, 1, 1, 1 ] ]

num_6 =   [[ 1, 1, 1, 1, 1 ],
				[ 1, 0, 0, 0, 0 ],
				[ 1, 0, 0, 0, 0 ],
				[ 1, 0, 0, 0, 0 ],
				[ 1, 1, 1, 1, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 1, 1, 1, 1 ] ]

num_7 =  [ [ 1, 1, 1, 1, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 0, 0, 0, 0, 1 ],
				[ 0, 0, 0, 1, 0 ],
				[ 0, 0, 1, 0, 0 ],
				[ 0, 1, 0, 0, 0 ],
				[ 0, 1, 0, 0, 0 ],				
				[ 1, 0, 0, 0, 0 ] ]

num_8 =   [[ 1, 1, 1, 1, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 1, 1, 1, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 1, 1, 1, 1 ] ]

num_9 =   [[ 1, 1, 1, 1, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 0, 0, 0, 1 ],
				[ 1, 1, 1, 1, 1 ],
				[ 0, 0, 0, 0, 1 ],
				[ 0, 0, 0, 0, 1 ],
				[ 0, 0, 0, 0, 1 ],				
				[ 1, 1, 1, 1, 1 ] ]
				
space = 		[[ 0, 0, 0, 0, 0 ],
					[ 0, 0, 0, 0, 0 ],
					[ 0, 0, 0, 0, 0 ],
					[ 0, 0, 0, 0, 0 ],
					[ 0, 0, 0, 0, 0 ],
					[ 0, 0, 0, 0, 0 ],
					[ 0, 0, 0, 0, 0 ],
					[ 0, 0, 0, 0, 0 ] ]

dot = 		    [[ 0, 0, 0, 0, 0 ],
					[ 0, 0, 0, 0, 0 ],
					[ 0, 0, 0, 0, 0 ],
					[ 0, 0, 0, 0, 0 ],
					[ 0, 0, 0, 0, 0 ],
					[ 0, 0, 0, 0, 0 ],
					[ 1, 1, 0, 0, 0 ],
					[ 1, 1, 0, 0, 0 ] ]

dbl_quotes =  [[ 1, 1, 0, 0, 0 ],
					[ 1, 1, 0, 0, 0 ],
					[ 1, 1, 0, 0, 0 ],
					[ 0, 0, 0, 0, 0 ],
					[ 0, 0, 0, 0, 0 ],
					[ 0, 0, 0, 0, 0 ],
					[ 0, 0, 0, 0, 0 ],
					[ 0, 0, 0, 0, 0 ] ]

colon		= [[ 0, 0, 0, 0, 0 ],
					[ 1, 1, 0, 0, 0 ],
					[ 1, 1, 0, 0, 0 ],
					[ 0, 0, 0, 0, 0 ],
					[ 0, 0, 0, 0, 0 ],
					[ 1, 1, 0, 0, 0 ],
					[ 1, 1, 0, 0, 0 ],
					[ 0, 0, 0, 0, 0 ] ]

plus        =  [[ 0, 0, 1, 0, 0 ],
					[ 0, 0, 1, 0, 0 ],
					[ 0, 0, 1, 0, 0 ],
					[ 1, 1, 1, 1, 1 ],
					[ 1, 1, 1, 1, 1 ],
					[ 0, 0, 1, 0, 0 ],
					[ 0, 0, 1, 0, 0 ],
					[ 0, 0, 1, 0, 0 ] ]

minus	   = [[ 0, 0, 0, 0, 0 ],
					[ 0, 0, 0, 0, 0 ],
					[ 0, 0, 0, 0, 0 ],
					[ 1, 1, 1, 1, 1 ],
					[ 1, 1, 1, 1, 1 ],
					[ 0, 0, 0, 0, 0 ],
					[ 0, 0, 0, 0, 0 ],
					[ 0, 0, 0, 0, 0 ] ]


alphabet = { "A": letter_A, "B": letter_B, "C": letter_C, "D": letter_D, "E": letter_E, "F": letter_F, "G": letter_G, "H": letter_H, "I": letter_I, "J": letter_J, "K": letter_K, "L": letter_L, "M": letter_M, "N": letter_N, "O": letter_O, "P": letter_P, "Q": letter_Q, "R": letter_R, "S": letter_S, "T": letter_T, "U": letter_U, "V": letter_V, "W": letter_W, "X": letter_X, "Y": letter_Y, "Z": letter_Z, "0": num_0, "1": num_1, "2": num_2, "3": num_3, "4": num_4, "5": num_5, "6": num_6, "7": num_7, "8": num_8, "9": num_9, " ": space, ".": dot, "\"": dbl_quotes, ":": colon, "+": plus, "-": minus }


class Word( pygame.sprite.Sprite ):
	"""
	Creates an object that represents a single world using rectangles.
	"""

	def __init__( self, string, top_left, colour, rectangle_size = 5 ):
		"""
		"""
		pygame.sprite.Sprite.__init__( self )

		# properties.
		self.string = string
		self.top_left = top_left
		self.colour = colour
		self.rectangle_size = rectangle_size

		self.name = ""

		self.n_letters = len( self.string )

		self.create_word()

		half_height = self.rect.height / 2
		width = self.rect.width

		for x in xrange( half_height ):
			pygame.draw.line( self.image, ( ( 0, 0, 0 ) ), ( 0, x * 2 ), ( width, x * 2 ), 1 )

		for x in range( width / 2 ):
			pygame.draw.line( self.image, (( 0, 0, 0 ) ), ( x * 2, 0 ), ( x * 2, half_height * 2 ), 1 )


	def create_word( self ):
		"""
		"""

		self.image = pygame.Surface( ( self.n_letters * self.rectangle_size * 6, self.rectangle_size * 8 ) )
		self.rect = self.image.get_rect( topleft = ( self.top_left ) )

		self.display_letter_where = [ 0, 0 ]


		for letter in xrange( len( self.string ) ):
			letter = Letter( self.string[letter], [0,0], self.colour, self.rectangle_size )
			self.image.blit( letter.image, [ self.display_letter_where[0], 0, self.rectangle_size * 6, self.rectangle_size * 8 ] )
			self.display_letter_where[0] += self.rectangle_size * 6


		self.image.set_colorkey( ( 0, 0, 0 ) )
			
class Letter( pygame.sprite.Sprite ):
	"""
	Creates an object that represents a single letter using rectangles.
	"""

	def __init__( self, letter, top_left, colour, square_size = 5 ):
		"""
		"""
		pygame.sprite.Sprite.__init__( self )

		# Properties.
		self.letter = letter # The letter to draw on a surface
		self.letter_layout = alphabet[letter] # The layout of the letter to display
		self.top_left = top_left # Where to display the letter.
		
		self.colour = colour # Colour
		self.square_size = square_size # The size of a single square
		self.squares_x = 6 # Squares on the x axis
		self.squares_y = 8 # Squares on the y axis

		self.image = pygame.Surface( ( self.squares_x * self.square_size, self.squares_y * self.square_size ) )
		self.rect = self.image.get_rect()

		
		self.draw_letter_on_surface()


	def draw_letter_on_surface( self ):
		"""
		"""
		

		for x in range( len( self.letter_layout ) ):
			for y in range( len( self.letter_layout[x] ) ):
				if self.letter_layout[x][y] == 1:
					# A square should be drawn.
					square = pygame.Surface( ( self.square_size, self.square_size ) )
					square.fill( self.colour )
					rect = square.get_rect( topleft = ( y * self.square_size, x * self.square_size ) )

					self.image.blit( square, rect )
